Subject: Re: [Roll] DIO DAGRank field

From: Richard Kelsey <[email-masked]>
Date: Wed, 06 Jan 2010 09:59:12 -0500

Phil, 

> From: Philip Levis <[email-masked]>
> Date: Tue, 29 Dec 2009 12:06:44 -0800
>
> Richard -- I agree with your analysis of Rank. Right now it seems to
> be a bit vague, and operating under the assumption that we'll figure
> it out later. It is a mix of a logical property for loop avoidance and
> a route quality property. It should be clearly one or the other.

For additive metrics like ETX there is no need for separate
rank and metric values.  The metric on its own is sufficient
for loop avoidance.

> At
> the very least, if we follow the current hybrid approach, there need
> to be constraints on how much Rank can increment on each hop, and this
> value needs to be considered in the field width. For example, with OF0
> it's a bit strange that two neighbors, both of whom have a hopcount of
> 2, can have Ranks of 2 and 32. I'm also a bit worried as to how Rank
> will translate from highly variable metrics such as latency, or
> decreasing metrics, such as a throughput.

Latency, being additive, works fine for loop avoidance on
its own.  As for throughput, I would think that any DAG
would require some additive metric in addition to
throughput, in order to prefer shorter paths over longer
ones with the same throughput.

> These are the kinds of things we should be discussing and resolving
> with respect to the draft. Before we start adding additional
> mechanisms for optimization, we need to make sure the existing ones
> are sound and effective.

Not to mention being understood.  As things stand now, for
additive metrics like ETX the rank is unnecessary and for
non-additive metrics like throughput its usage and effects
are unclear.

> It seems to me that RPL would be much simpler if there were a strong
> division between Rank and metric, with the former being used for loop
> avoidance and detection and the latter being used for route
> optimization.

I don't think that is possible with a single, fixed-width
rank field.  Dynamic Source Routing would work, but that
would require keeping the entire path in the DIOs.

                                 -Richard Kelsey